/****************************************************************************
**
** Copyright (C) 2020 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of TreeView.
**
** $QT_BEGIN_LICENSE:GPL-MARKETPLACE-QT$
**
** Marketplace License Usage
** Users, who have licensed the Software under the Qt Marketplace license
** agreement, may use this file in accordance with the Qt Marketplace license
** agreement provided with the Software or, alternatively, in accordance with
** the terms contained in a written agreement between the licensee and The Qt
** Company. For licensing terms and conditions see
** https://www.qt.io/terms-conditions/#marketplace and
** https://www.qt.io/terms-conditions. For further information use the contact
** form at https://www.qt.io/contact-us.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3 or (at your option) any later version
** approved by the KDE Free Qt Foundation. The licenses are as published by
** the Free Software Foundation and appearing in the file LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

#include <QtGui>
#include <QtWidgets/QApplication>
#include <QtQml>
#include <QtQuick>
#include <QFileSystemModel>

#include "tree.h"


int main(int argc, char **argv){
    QApplication app(argc, argv);

//    QFileSystemModel model;
//    model.setRootPath("/");

//    TreeWrapper tree;
//    tree.setRootPath("/");
    MyTree tree;

    auto create = [](QString label)
    {
        return std::make_unique<TreeItem<TreeData>>(TreeData{label});
    };

    for (int i = 0; i < 100; ++i)
    {
        auto top = tree.appendItem(*tree.root(), create("label " + QString::number(i)));

        for (int j = 0; j < 10; ++j)
            tree.appendItem(*top, create("sub-label " + QString::number(j)));
    }

    QQmlApplicationEngine engine;
    engine.rootContext()->setContextProperty("fileSystemModel", &tree);
    engine.load(QUrl(QStringLiteral("qrc:///main.qml")));

    return app.exec();
}

