#pragma once

#include <QFileSystemModel>
#include "tree_util.h"


struct TreeData
{
    TreeData() = default;
    TreeData(QString label) : label(label) {}

    QString label;
};

class MyTree : public TreeModel<TreeData>
{
    Q_OBJECT

public slots:
    QModelIndex rootIndex() const;
    QModelIndex firstChild(QModelIndex parent) const;
    QModelIndex nextSibling(QModelIndex index) const;
    static bool isValid(QModelIndex index);
    QString     childLabel(QModelIndex index) const;

public:
    virtual QVariant data(const QModelIndex &index, int ) const override
    {
        if (auto item = getTreeItem(index))
        {
            return item->data.label;
        }

        return {};
    }

    virtual int columnCount(const QModelIndex &) const override
    {
        return 10;
    }
};
